## ----setup, include=FALSE------------------------------------------------
###tags=variables,R,변수,알
###category=변수, 데이터형, 연산, 함수, 특별한값
knitr::opts_chunk$set(echo = TRUE)
load('linespreadtable.RData')
load('linespread.RData')
load('linespreadcode.RData')


## ------------------------------------------------------------------------
myAge = 22
year = 2018
day_of_Month = 3 # Alphabets , numbers , '.', '_'
stock.high = 13322
whatIGotForMy23thBirthday = "flowers"


## ------------------------------------------------------------------------
# Assign
a <- 3
b = 2
-1 -> d
e1 <- e2 <- 7

assign("var1", 3)
varname = "myVariable" # Camel case
assign(varname , 2)

# Naming Convention
myVariable = 1 # Camel case/Pascal case
varname2 = "my_Another_Variable" # Python
varname3 = "myVariable.3rd" # R
assign(varname2 , 2)
assign(varname3 , 2)


## ------------------------------------------------------------------------
e2 <- e1 <- 7
e1 = e2 = 7
7 -> e1 -> e2


## ------------------------------------------------------------------------
e1 * 3
d1 <- e1 * 3
(d2 <- e1 * 3)


## ---- eval=F-------------------------------------------------------------
## rm(list=ls())


## ---- eval=F-------------------------------------------------------------
## a = 2; b = function(x) x^2; cc = "Now"
## ls()

## ---- echo=F-------------------------------------------------------------
#rm(list=ls())
a = 2; b = function(x) x^2; cc = "Now"
ls(pattern="^(a|b|cc)$")


## ---- tidy=FALSE, eval=FALSE---------------------------------------------
## str(a); str(b); str(cc);
## 
## ## num 2
## 
## ## function (x)
## ## - attr(*, "srcref")= ' srcref ' int [1:8] 2 12 2 26 12 26 2 2
## ## ..- attr(*, "srcfile")=Classes ' srcfilecopy ' , ' srcfile ' <environ...
## 
## ## chr "Now"


## ---- eval=F-------------------------------------------------------------
## ls.str()

## ---- echo=F-------------------------------------------------------------
ls.str(pattern="^(a|b|cc)$")


## ---- results='hold', tidy=FALSE-----------------------------------------
exists("a"); exists("d")


## ---- eval=F-------------------------------------------------------------
## ls() # 현재 저장된 변수 이름을 보여준다.
## rm("a") # 변수 a를 제거한다.
## ls() # 변수 a가 제거되었음을 확인한다.
## rm(list=ls()) # 모든 변수를 제거한다.
## ls() # 모든 변수가 제거되었음을 확인한다.


## ---- eval=F-------------------------------------------------------------
## rm(list = setdiff(ls(), lsf.str()))


## ------------------------------------------------------------------------
save.image()


## ------------------------------------------------------------------------
load('.RData')


## ---- results='hold', tidy=FALSE-----------------------------------------
x1 = 23L; class(x1)
x2 = 22.3; class(x2)
x3 = "strings"; class(x3)
x4 = factor(c("Hi", "Lo", "Lo")); class(x4)
x5 = as.Date("2020-01-01"); class(x5)
x6 = as.POSIXct("2020-01-01 12:11:11"); class(x6)
"POSIXct" %in% class(x6)
inherits(x6, "POSIXct")


## ---- results='hold', tidy=FALSE-----------------------------------------
y1 = "23"; as.integer(y1)
y2 = "22.3"; as.numeric(y2)
y3 = "strings"
y4 = c("Hi", "Lo", "Lo"); as.factor(y4)
y5 = "2020-01-01"; as.Date(y5)
y6 = "2020-01-01 12:11:11"; as.POSIXct(y6)


## ---- eval=F, tidy=FALSE-------------------------------------------------
## 3 + 2
## 5 - 4
## 3 * 2
## 72 / 2
## 3 ^ 4; 3 ** 4
## 3 ^ (1/2); sqrt(3)
## 3 - 2 + 2 * 4 / 2 ^ (1 + 1)
## 7 / 3 # 나눗셈(Float division)
## 7 %/% 3 # 정수나누기, 몫(Integer division)
## 7 %% 3 # 나머지(Remainder)


## ---- results='hold'-----------------------------------------------------
exp(1)
log(180, base=2); log2(180)
log10(180)
sin(2)


## ---- results='hold'-----------------------------------------------------
"+"(3,2)
"*"(3,2)
"%p%" = function(x,y) { 2^x + y^2 }
3 %p% 2
"%p%"(3,2)


## ---- results='hold', tidy=FALSE-----------------------------------------
"+" = function(x, y) x*y
3+2; 3+3
"+"


## ---- include=FALSE------------------------------------------------------
rm("+")


## ---- results='hold'-----------------------------------------------------
7 < 3
7 > 3
7 == 3
7 != 3


## ---- results='hold'-----------------------------------------------------
sqrt(2)^2 == 2
print(sqrt(2)^2)
print(sqrt(2)^2, digits = 21)


## ---- results='hold'-----------------------------------------------------
all.equal(sqrt(2)^2, 2)
all.equal(1e-23, 1e-24)


## ------------------------------------------------------------------------
dplyr::near(1e-23, 1e-24)
near <- dplyr::near; near(1e-23, 1e-24)


## ---- results='hold'-----------------------------------------------------
print("Letter")
cat('Letter')

## ---- results='hold'-----------------------------------------------------
print('"Hello", says he')
cat('"Hello", says he')

## ---- results='hold'-----------------------------------------------------
print('Cheer up!\r\nRight Now!')
cat('Cheer up!\r\nRight Now!')


## ---- results='hold'-----------------------------------------------------
nchar('hello?') # 문자 갯수
paste('Here is', 'an apple.') # 문자열 연결
substring('hello?', 2, 3) # 문자열의 일부분


## ---- results='hold'-----------------------------------------------------
Sys.Date() # 현재 날짜
Sys.time() # 현재 날짜와 시간(POSIXct 형식)


## ---- results='hold'-----------------------------------------------------
as.Date("2018/12/31") # 문자열 "2018/12/31"을 날짜 형식으로
# 문자열 "2018/12/31 23:59:59"을 날짜시간 형식으로
as.POSIXct("2018/12/31 23:59:59") 


## ---- results='hold'-----------------------------------------------------
Sys.Date() - as.Date("2019-01-01") # 2018년 1월 1일과 현재 날짜의 차이
# 현재 날짜 시간과 2019년 12월 31일 23시 59분 59초의 차이
as.POSIXct("2019/12/31 23:59:59")-Sys.time()


## ---- results='hold'-----------------------------------------------------
# 현재 날짜 시간과 2018년 12월 31일 23시 59분 59초와의 차이
difftime(as.POSIXct("2018/12/31 23:59:59"), Sys.time()) 
# 현재 날짜 시간과 2018년 12월 31일 23시 59분 59초와의 차이(분 단위로)
difftime(as.POSIXct("2018/12/31 23:59:59"), Sys.time(), units='mins')
# 현재 날짜 시간과 2018년 12월 31일 23시 59분 59초와의 차이(초 단위로)
difftime(as.POSIXct("2018/12/31 23:59:59"), Sys.time(), units='secs')
# units은 다음 중 하나: 'auto', 'secs', 'mins', 'hours', 'days', 'weeks'


## ---- results='hold'-----------------------------------------------------
as.numeric(as.POSIXct("2018/12/31 23:59:59"))-as.numeric(Sys.time())


## ----error=T-------------------------------------------------------------
'2020-01-01'-'2019-12-31'
as.Date('2020-01-01')-as.Date('2019-12-31')


## ---- results='hold'-----------------------------------------------------
(7 < 3) & (4 > 3)
(7 < 3) | (4 > 3)
!(7 < 3)
xor(T, T) # XOR
x = NA
isTRUE(x == 3) # robust to NAs


## ----error=T-------------------------------------------------------------
TRUE <- c(3,2) 
T <- c(3,2) 
T 


## ----include=FALSE-------------------------------------------------------
T <- TRUE


## ---- results='hold'-----------------------------------------------------
1.32e+308
1.32e+308*10


## ---- include=F----------------------------------------------------------
linespread=1.2


## ------------------------------------------------------------------------
x <- c(2, 5, NA, 3)
vec <- c(3, 7, 0, NA, -3)
# x %in% vec와 비교해 보자.
ifelse(is.na(x), NA, x %in% vec)


## ---- include=F----------------------------------------------------------
linespread=1.2


## ---- include=F----------------------------------------------------------
linespread=1.2


## ---- include=F----------------------------------------------------------
linespread=1.2

